﻿Imports Telerik.Web.UI
Imports System.Data

Partial Class RadGridHierarchyErrManagementVB
    Inherits System.Web.UI.Page

    Dim sb As StringBuilder
    Protected Sub Page_PreInit(sender As Object, e As EventArgs) Handles Me.PreInit
        sb = New StringBuilder("<b>Grids bound:</b><br/>")
    End Sub
    Protected Sub Page_PreRender(sender As Object, e As EventArgs) Handles Me.PreRender
        Label1.Text = sb.ToString()
    End Sub
    Protected Sub grdErrManagement_NeedDataSource(sender As Object, e As GridNeedDataSourceEventArgs)
        grdErrManagement.DataSource = GetGridSource(80)
        sb.Append(DirectCast(sender, RadGrid).UniqueID + "<br/>")
    End Sub
    Protected Sub grdErrFiles_NeedDataSource(sender As Object, e As GridNeedDataSourceEventArgs)
        BindInnerGrid(DirectCast(sender, RadGrid))
        sb.Append(DirectCast(sender, RadGrid).UniqueID + "<br/>")
    End Sub
    Private Sub BindInnerGrid(grid As RadGrid)
        Dim parentItem As GridDataItem = DirectCast(grid.NamingContainer, GridNestedViewItem).ParentItem
        Dim value As System.Nullable(Of Integer) = DirectCast(parentItem.GetDataKeyValue("OrderID"), System.Nullable(Of Integer))
        grid.DataSource = GetGridSource(value.Value)
    End Sub
    Private Function GetGridSource(customCondition As Integer) As DataTable
        Dim dataTable As New DataTable()

        Dim column As New DataColumn()
        column.DataType = Type.[GetType]("System.Int32")
        column.ColumnName = "OrderID"
        dataTable.Columns.Add(column)

        column = New DataColumn()
        column.DataType = Type.[GetType]("System.DateTime")
        column.ColumnName = "OrderDate"
        dataTable.Columns.Add(column)

        column = New DataColumn()
        column.DataType = Type.[GetType]("System.Decimal")
        column.ColumnName = "Freight"
        dataTable.Columns.Add(column)

        column = New DataColumn()
        column.DataType = Type.[GetType]("System.String")
        column.ColumnName = "ShipName"
        dataTable.Columns.Add(column)

        column = New DataColumn()
        column.DataType = Type.[GetType]("System.String")
        column.ColumnName = "ShipCountry"
        dataTable.Columns.Add(column)

        Dim PrimaryKeyColumns As DataColumn() = New DataColumn(0) {}
        PrimaryKeyColumns(0) = dataTable.Columns("OrderID")
        dataTable.PrimaryKey = PrimaryKeyColumns

        For i As Integer = 0 To customCondition - 1
            Dim row As DataRow = dataTable.NewRow()
            row("OrderID") = i + 1
            row("OrderDate") = DateTime.Now
            row("Freight") = (i + 1) + (i + 1) * 0.1 + (i + 1) * 0.01
            row("ShipName") = "Name " & (i + 1)
            row("ShipCountry") = "Country " & (i + 1)

            dataTable.Rows.Add(row)
        Next

        Return dataTable
    End Function
    Protected Sub tstrpErr_TabClick(sender As Object, e As RadTabStripEventArgs)
    End Sub
    Protected Sub grdErrFiles_ItemDataBound(sender As Object, e As GridItemEventArgs)
    End Sub
    Protected Sub lbnFilename_Click(sender As Object, e As EventArgs)
    End Sub
    Protected Sub tbErrManagement_ButtonClick(sender As Object, e As RadToolBarEventArgs)
    End Sub
    Protected Sub grdErrManagement_ItemCommand(sender As Object, e As GridCommandEventArgs)
        If e.CommandName = RadGrid.ExpandCollapseCommandName Then
            DirectCast(e.Item, GridDataItem).ChildItem.FindControl("InnerContainer").Visible = Not e.Item.Expanded
            If Not e.Item.Expanded Then
                Dim grid As RadGrid = DirectCast(e.Item, GridDataItem).ChildItem.FindControl("grdErrFiles")
                grid.Rebind()
            End If
        End If
    End Sub
End Class
